Subject: Re: [nfsv4] [Federated-fs] Comments on requirements document

From: Renu Tewari <[email-masked]>
Date: Wed, 29 Oct 2008 10:07:55 -0700

One thing I wanted to highlight, and I think James mentioned it, that one
way of thinking of singleton servers was as legacy servers that do not
understand or parse any of the federated-fs protocols but can still be part
of the federation as the target of a referral. The idea was to expand the
scope of the federation to include such servers. For example a v3 server
can be part of the federation as the target of the referral and knows
nothing of fed-fs.

regards
Renu

===================
Renu Tewari, Ph.D.
Research Staff Member
Networked Filesystems
IBM Almaden

             James Lentini                                                 
             <jlentini@netapp.                                             
             com>                                                       To 
             Sent by:                  Robert Thurlow                      
             federated-fs-boun         <[email-masked]>            
             [email-masked]                                               cc 
                                       "Lentini, James"                    
                                       <[email-masked]>,         
             10/29/2008 08:20          [email-masked],              
             AM                        [email-masked]                      
                                                                   Subject 
                                       Re: [Federated-fs] [nfsv4]          
                                       Comments on requirements document   

                                                                           

On Tue, 28 Oct 2008, Robert Thurlow wrote:

> James Lentini wrote:
>
> > I agree with the conclusions of this thread that singleton servers are
> > important and that the terminology is confusing. I'll point out that in
the
> > original introduction (page 5
draft-ietf-nfsv4-federated-fs-reqts-00.txt),
> > the text reads:
> >
> >  There are also singleton servers that export some or all of their
> >  filesystem resources, but which do not contain junctions to other
> >  filesystems.
> >
> > In other words a singleton server is a fileserver can be the target of
a
> > referral, but will not return a referral. I believe that this was a
typo.
>
> Does highlighting this type of server have value?  Why?  What
> do we need to say about them?
>
> > In the Glossary on page 14, the following definition is given:
> >
> >    Singleton Server:  A server collection containing only one server; a
> >       stand-alone fileserver.
> >
> > which implies that a singleton server can both be the target of a
> > referral and generate a referral.
>
> I'd prefer to talk somewhere about the fact that a collection
> can shrink to a single fileserver plus an NSDB, and try to
> avoid defining a new term unless we need to refer to it in
> multiple places.

Sure, defining the term singleton server isn't important. The goal is
to make clear that different storage systems (clusters, single
servers, ...) can participate in the federation.

_______________________________________________
nfsv4 mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/nfsv4

---

From: "Everhart, Craig" <[email-masked]>
Date: Sat, 8 Nov 2008 11:20:33 -0500

Thanks, Renu.  Actually, I think that legacy servers that can act as
leaves-only are different from singleton servers that might in principle
be fully federation-capable (serving NFSv4 and using an NSDB server).
 
We haven't really crafted a place yet, I don't believe, for the
nfsv3-only server in FedFS.  I believe that the NFSv4 documents mention
targets of referrals as NFSv4 servers in their own right; in particular,
all the discussion about obtaining, say, more-authoritative
fs_location_info about the target filesystem from the target server
after crossing the junction wouldn't apply if the target server were not
serving NFSv4.
 
The requirements express a wish for federation to work with varied
protocols.  I don't think the protocol drafts are enough to make this
happen.  If nothing else, they still assume that the referral work is
all done using off-the-shelf protocols.  I know we've had some
discussions about what pragmatically happens with different kinds of
clients (nfs incl. v4, and Windows), but there are details to work out
in this space.
 
        Craig

________________________________

	From: Renu Tewari [mailto:[email-masked]] 
	Sent: Wednesday, October 29, 2008 1:08 PM
	To: Lentini, James
	Cc: [email-masked]; Lentini, James; Robert
Thurlow; [email-masked]; [email-masked]
	Subject: Re: [nfsv4] [Federated-fs] Comments on requirements
document

	One thing I wanted to highlight, and I think James mentioned it,
that one way of thinking of singleton servers was as legacy servers that
do not understand or parse any of the federated-fs protocols but can
still be part of the federation as the target of a referral. The idea
was to expand the scope of the federation to include such servers. For
example a v3 server can be part of the federation as the target of the
referral and knows nothing of fed-fs. 
	
	regards 
	Renu 
	
	===================
	Renu Tewari, Ph.D.
	Research Staff Member
	Networked Filesystems 
	IBM Almaden
	 James Lentini <[email-masked]>

				James Lentini <[email-masked]> 
				Sent by: [email-masked] 

				10/29/2008 08:20 AM

To

Robert Thurlow <[email-masked]>	

cc

"Lentini, James" <[email-masked]>, [email-masked],
[email-masked]	

Subject

Re: [Federated-fs] [nfsv4] Comments on requirements document	

	
	On Tue, 28 Oct 2008, Robert Thurlow wrote:
	
	> > important and that the terminology is confusing. I'll point
out that in the
	> > In other words a singleton server is a fileserver can be the
target of a
	> > referral, but will not return a referral. I believe that
this was a typo.
	> avoid defining a new term unless we need to refer to it in
	
	Sure, defining the term singleton server isn't important. The
goal is 
	to make clear that different storage systems (clusters, single 
	servers, ...) can participate in the federation.

---

From: "Renu Tewari" <[email-masked]>
Date: Tue, 11 Nov 2008 15:46:06 -0800

The SHOULD should work :)
 So it SHOULD be possible to have the target of a referral point to a
fileserver that is not fed-fs aware.

On Tue, Nov 11, 2008 at 6:52 AM, Everhart, Craig
<[email-masked]> wrote:
> Right--the reqs don't talk about a mixed protocol environment.
>
> How would you include such a discussion, as a nice-to-have?  Or would
> you be interested in going more into SHOULD territory?
>
> Your response was just to me, not to the list, in case that's an
> omission.
>
oops added the list now.

renu

>                Craig
>
>> -----Original Message-----
>> From: Renu Tewari [mailto:[email-masked]]
>> Sent: Tuesday, November 11, 2008 2:03 AM
>> To: Everhart, Craig
>> Subject: Re: [nfsv4] [Federated-fs] Comments on requirements document
>>
>> So I agree that legacy/singleton maybe two different things.
>> Depends on how we have defined it. But the idea is that we
>> need to be able to include servers that can be targets of a
>> referral but may not be fully fed-fs capable. We don't talk
>> about it but may be we should expand on this. Most customers
>> want to include their existing servers in any deployment and
>> given that the NFS world is not yet all v4 this may be
>> practical thing to work out.
>>
>> renu
>>
>>
>> On Sat, Nov 8, 2008 at 8:20 AM, Everhart, Craig
>> <[email-masked]> wrote:
>> > leaves-only are different from singleton servers that might in
>> > principle be fully federation-capable (serving NFSv4 and
>> using an NSDB server).
>> >
>> > nfsv3-only server in FedFS.  I believe that the NFSv4 documents
>> > mention targets of referrals as NFSv4 servers in their own
>> right; in
>> > particular, all the discussion about obtaining, say,
>> > more-authoritative fs_location_info about the target
>> filesystem from
>> > the target server after crossing the junction wouldn't
>> apply if the target server were not serving NFSv4.
>> >
>> > clients (nfs incl. v4, and Windows), but there are details
>> to work out in this space.
>> >
>> >         Craig
>> >
>> > Cc: [email-masked]; Lentini, James; Robert Thurlow;
>> > [email-masked]; [email-masked]
>> > Subject: Re: [nfsv4] [Federated-fs] Comments on
>> requirements document
>> >
>> > One thing I wanted to highlight, and I think James
>> mentioned it, that
>> > one way of thinking of singleton servers was as legacy
>> servers that do
>> > not understand or parse any of the federated-fs protocols but can
>> > Robert Thurlow <[email-masked]> cc "Lentini, James"
>> > <[email-masked]>, [email-masked], [email-masked]
>> > Subject
>> >> > In other words a singleton server is a fileserver can be
>> the target of a
>> this was a

---

From: Rob Thurlow <[email-masked]>
Date: Wed, 12 Nov 2008 14:08:25 -0700

Renu Tewari wrote:
> One thing I wanted to highlight, and I think James mentioned it, that 
> one way of thinking of singleton servers was as legacy servers that do 
> not understand or parse any of the federated-fs protocols but can still 
> be part of the federation as the target of a referral. The idea was to 
> expand the scope of the federation to include such servers.

Agreed on this.  Could I propose we call these 'leaf servers'?

I'm afraid I'm not sure about NFSv3 targets, either :-)

Rob T